#include "localsearch.h"

int evaluate_exchange_nonfunziona (point p_in, point p_out, solution_t *px, data_t *pI)
{
  int delta_f;

  delta_f = -px->f;
  move_point_in(p_in,px,pI);
  move_point_out(p_out,px,pI);
  delta_f += px->f;
  move_point_out(p_in,px,pI);
  move_point_in(p_out,px,pI);

  return delta_f;
}

int evaluate_exchange_old (point p_in, point p_out, solution_t *px, data_t *pI)
{
  point p;
  int delta;


  delta = 0;
  for (p = first_point_in(px); !end_point_list(p,px); p = next_point(p,px))
  {
    if (p != p_out) delta += pI->d[get_point(p_in,px)][get_point(p,px)];
    delta -= pI->d[get_point(p_out,px)][get_point(p,px)];
  }

  return delta;
}

int evaluate_exchange (point p_in, point p_out, solution_t *px, data_t *pI)
{
  return   px->D[get_index(p_in,px)]
         - pI->d[get_index(p_in,px)][get_index(p_out,px)]
         - px->D[get_index(p_out,px)];
}

void find_best_exchange (solution_t *px, data_t *pI, point *pp_in, point *pp_out, int *pdelta_f)
{
  point p_in, p_out;
  int delta_f;

  *pdelta_f = INT_MIN;
  *pp_in = *pp_out = NO_POINT;
  for (p_in = first_point_out(px); !end_point_list(p_in,px); p_in = next_point(p_in,px))
    for (p_out = first_point_in(px); !end_point_list(p_out,px); p_out = next_point(p_out,px))
    {
      delta_f = evaluate_exchange(p_in,p_out,px,pI);
      if (delta_f > *pdelta_f)
      {
        *pdelta_f = delta_f;
        *pp_in = p_in;
        *pp_out = p_out;
      }
    }
}


void find_first_exchange (solution_t *px, data_t *pI, point *pp_in, point *pp_out, int *pdelta_f)
{
  point p_in, p_out;
  int delta_f;

  *pdelta_f = INT_MIN;
  *pp_in = *pp_out = NO_POINT;
  for (p_in = first_point_out(px); !end_point_list(p_in,px); p_in = next_point(p_in,px))
    for (p_out = first_point_in(px); !end_point_list(p_out,px); p_out = next_point(p_out,px))
    {
      delta_f = evaluate_exchange(p_in,p_out,px,pI);
      if (delta_f > *pdelta_f)
      {
        *pdelta_f = delta_f;
        *pp_in = p_in;
        *pp_out = p_out;
        if (delta_f > 0) return;
      }
    }
}

void steepest_descent (data_t *pI, solution_t *px)
{
/*
  Do
   (p_in,p_out,delta_f) := esplora_intorno(x);
   If (delta_f > 0) esegue_mossa(px,p_in,p_out)
  While (delta_f > 0);
*/

  point p_in, p_out;
  int delta_f;


  do
  {
    find_first_exchange(px,pI,&p_in,&p_out,&delta_f);
    if (delta_f > 0)
    {
      move_point_in(p_in,px,pI);
      move_point_out(p_out,px,pI);
    }

  } while (delta_f > 0);
}
